﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Specialized;
using System.Collections.Generic;
using Com.Alipay;

/// <summary>
/// 功能：服务器异步通知页面
/// 版本：3.3
/// 日期：2012-07-10
/// 说明：
/// 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
/// 该代码仅供学习和研究支付宝接口使用，只是提供一个参考。
/// 
/// ///////////////////页面功能说明///////////////////
/// 创建该页面文件时，请留心该页面文件中无任何HTML代码及空格。
/// 该页面不能在本机电脑测试，请到服务器上做测试。请确保外部可以访问该页面。
/// 该页面调试工具请使用写文本函数logResult。
/// 如果没有收到该页面返回的 success 信息，支付宝会在24小时内按一定的时间策略重发通知
///function:Server asynchronous notification page
///version:3.3
///modify date：2012-08-17
///instruction:
///This code below is a sample demo for merchants to do test.Merchants can refer to the integration documents and write your own code to fit your website.Not necessarily to use this code.  
///Alipay provide this code for you to study and research on Alipay interface, just for your reference.

/// ///////////////////function description///////////////////
/// When creating this page file, please pay attention and ensure there's not any HTML code and space in the page file.
/// This page cannot be tested locally. Please do the test on the server and make sure that it is accessable from outer net.
///The page debugging tool, please use the function logResult to write the log
///If Alipay system do not receive success returned on this page, If not, Alipay server would keep re-sending notification until over 24 hour according to retransmission strategy
/// </summary>
public partial class notify_url : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        SortedDictionary<string, string> sPara = GetRequestPost();

        if (sPara.Count > 0)//判断是否有带返回参数check whether there's any para
        {
            Notify aliNotify = new Notify();
            bool verifyResult = aliNotify.Verify(sPara, Request.Form["notify_id"], Request.Form["sign"]);

            if (verifyResult)//验证成功 verification is succeeded
            {
                /////////////////////////////////////////////////////////////////////////////////////////////////////////////
                //请在这里加上商户的业务逻辑程序代码
				//Please add yourprogram code here according to your business logic.


                //——请根据您的业务逻辑来编写程序（以下代码仅作参考）——
                //获取支付宝的通知返回参数，可参考技术文档中服务器异步通知参数列表
				//——Please write program according to your business logic.(The below code is for your reference.)
			    //Get the returned parameters from notification.You can refer to alipay's notification parameters list in integration documents.

                //商户订单号
				//out_trade_no				

                string out_trade_no = Request.Form["out_trade_no"];

                //支付宝交易号
				//trade_no

                string trade_no = Request.Form["trade_no"];

                //交易状态
				//trade_status
                string trade_status = Request.Form["trade_status"];


                if (Request.Form["trade_status"] == "TRADE_FINISHED")
                {
                    //判断该笔订单是否在商户网站中已经做过处理		
                    //如果没有做过处理，根据订单号（out_trade_no）在商户网站的订单系统中查到该笔订单的详细，并执行商户的业务程序
		    //请务必判断请求时的total_fee、seller_id与通知时获取的total_fee、seller_id为一致的
                    //如果有做过处理，不执行商户的业务程序
			//Check whether the order has been processed in the partner's website.				
			//If it has not been processed,query the detail of the order in order system of your website according to the order number (out_trade_no) and perform program code of your business logic.
			//Please make sure the total_fee, seller_id get from notification are the same with the parameters in request.
			//If the order has been processed in the partner's website,do not perform your program code of business logic.
                    

                }
                else if(Request.Form["trade_status"] == "TRADE_SUCCESS")
                {
                    //判断该笔订单是否在商户网站中已经做过处理
                    //如果没有做过处理，根据订单号（out_trade_no）在商户网站的订单系统中查到该笔订单的详细，并执行商户的业务程序
		    //请务必判断请求时的total_fee、seller_id与通知时获取的total_fee、seller_id为一致的
                    //如果有做过处理，不执行商户的业务程序
			//Check whether the order has been processed in the partner's website.				
			//If it has not been processed,query the detail of the order in order system of your website according to the order number (out_trade_no) and perform program code of your business logic.
			//Please make sure the total_fee, seller_id get from notification are the same with the parameters in request.
			//If the order has been processed in the partner's website,do not perform your program code of business logic.

                    //注意：
					//note:
                    //付款完成后，支付宝系统发送该交易状态通知
					//When transanction finished,Alipay system will notification with trade status 
                }
                else
                {
                }

                //——请根据您的业务逻辑来编写程序（以上代码仅作参考）——
	            //—-Please write program according to your business logic.(The below code is for your reference.)
                Response.Write("success");  //请不要修改或删除do not modify or delete here

                /////////////////////////////////////////////////////////////////////////////////////////////////////////////
            }
            else//验证失败verification failed
            {
                Response.Write("fail");
            }
        }
        else
        {
            Response.Write("无通知参数No params");
        }
    }

    /// <summary>
    /// 获取支付宝POST过来通知消息，并以“参数名=参数值”的形式组成数组
	/// obtain the response message from Alipay servers by the way of POST .Connect params like"parameter=value" into an Array
    /// </summary>
    /// <returns>request回来的信息组成的数组 Array from returned info</returns>
    public SortedDictionary<string, string> GetRequestPost()
    {
        int i = 0;
        SortedDictionary<string, string> sArray = new SortedDictionary<string, string>();
        NameValueCollection coll;
        //Load Form variables into NameValueCollection variable.
        coll = Request.Form;

        // Get names of all forms into a string array.
        String[] requestItem = coll.AllKeys;

        for (i = 0; i < requestItem.Length; i++)
        {
            sArray.Add(requestItem[i], Request.Form[requestItem[i]]);
        }

        return sArray;
    }
}
